=== doc/publications/Makefile ===
# $Id: Makefile 9615 2004-09-14 17:02:20Z guido $

D = ../..
include $D/common/Make.global_options


# default: do nothing
default:


validate-xrefs:
	$(PERL) $D/common/scripts/validate-xrefs.pl *.html


.PHONY: default validate-xrefs
