=== debian/changelog ===
deal.ii (7.1.0-1) unstable; urgency=low

  [ Adam C. Powell, IV ]
  * New upstream (closes: #652057).
  * Updated to use PETSc and SLEPc 3.2, and forward-ported all patches.
  * Removed NetCDF Build-Depends because it uses serial HDF5.
  * Made Sacado cmath patch work with new configure.
  * Moved -dev package symlink lines in rules to arch all section.

  [ Christophe Trophime ]
  * debian/rules:
     - add dh_strip --dbg-package to generate dbg package (closes: #652058)
     - add .install files to simplify rules
  * Add support for mumps, arpack (closes: #637655)
  * Add patch for slepc 3.2 (closes: #659245)

 -- "Adam C. Powell, IV" <hazelsct@debian.org>  Tue, 21 Feb 2012 06:57:30 -0500
