=== debian/control ===
Source: deal.ii
Section: devel
Priority: extra
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: "Adam C. Powell, IV" <hazelsct@debian.org>
Standards-Version: 3.9.2
Build-Depends: debhelper (>= 7), quilt, automake, autoconf, gfortran, zlib1g-dev,
  libblas-dev, liblapack-dev, libpetsc3.2-dev (>= 3.2.dfsg-5), libslepc3.2-dev,
  libtrilinos-dev (>=9.0.2.dfsg-4), libscotchmetis-dev (>= 5.1.4.dfsg-2),
  libsuitesparse-dev, libboost-dev, libboost-graph-dev,
  libboost-python-dev, libtbb-dev, libtbb2-dbg, qt4-qmake, libqt4-dev,
  libarpack2-dev, libmumps-dev, libscalapack-mpi-dev, libblacs-mpi-dev
Build-Depends-Indep: doxygen-latex, graphviz, ghostscript
Vcs-Git: git://git.debian.org/git/debian-science/packages/deal.ii.git
Vcs-Browser: http://git.debian.org/?p=debian-science/packages/deal.ii.git
Homepage: http://www.dealii.org/

Package: libdeal.ii-dbg7.1.0
Architecture: any
Section: debug
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Finite element library - shared library
 deal.II is a C++ program library targeted at the computational
 solution of partial differential equations using adaptive finite elements.
 It uses state-of-the-art programming techniques to offer you a modern
 interface to the complex data structures and algorithms required.  The main
 aim of deal.II is to enable rapid development of modern finite element codes,
 using among other aspects adaptive meshes and a wide array of tools classes
 often used in a finite element program.
 .
 This package contains the debugging shared libraries.

Package: libdeal.ii-dbg
Architecture: all
Section: debug
Depends: libdeal.ii-dbg7.1.0 (>= ${source:Version}), ${misc:Depends}
Recommends: libdeal.ii-dev (= ${source:Version}), libtbb2-dbg
Description: Finite element library - development files
 deal.II is a C++ program library targeted at the computational
 solution of partial differential equations using adaptive finite elements.
 It uses state-of-the-art programming techniques to offer you a modern
 interface to the complex data structures and algorithms required.  The main
 aim of deal.II is to enable rapid development of modern finite element codes,
 using among other aspects adaptive meshes and a wide array of tools classes
 often used in a finite element program.
 .
 This package contains development files for using debugging shared libraries.

Package: libdeal.ii7.1.0
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Finite element library - shared library
 deal.II is a C++ program library targeted at the computational
 solution of partial differential equations using adaptive finite elements.
 It uses state-of-the-art programming techniques to offer you a modern
 interface to the complex data structures and algorithms required.  The main
 aim of deal.II is to enable rapid development of modern finite element codes,
 using among other aspects adaptive meshes and a wide array of tools classes
 often used in a finite element program.
 .
 This package contains the optimized shared libraries.

Package: libdeal.ii-dev
Architecture: all
Section: libdevel
Depends: libdeal.ii7.1.0 (>= ${source:Upstream-Version}), libdeal.ii7.1.0 (<< ${source:Upstream-Version}+1~), libblas-dev, liblapack-dev, libpetsc3.2-dev, libslepc3.2-dev, libtrilinos-dev (>=9.0.2.dfsg-3), libscotchmetis-dev (>= 5.1.4.dfsg-2), libsuitesparse-dev, libnetcdf-dev, libboost-dev, libtbb-dev, ${misc:Depends}
Suggests: libdeal.ii-dbg, deal.ii-doc, deal.ii-examples
Description: Finite element library - development files
 deal.II is a C++ program library targeted at the computational
 solution of partial differential equations using adaptive finite elements.
 It uses state-of-the-art programming techniques to offer you a modern
 interface to the complex data structures and algorithms required.  The main
 aim of deal.II is to enable rapid development of modern finite element codes,
 using among other aspects adaptive meshes and a wide array of tools classes
 often used in a finite element program.
 .
 This package contains development files for using optimized shared libraries.

Package: deal.ii-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Finite element library - documentation
 deal.II is a C++ program library targeted at the computational
 solution of partial differential equations using adaptive finite elements.
 It uses state-of-the-art programming techniques to offer you a modern
 interface to the complex data structures and algorithms required.  The main
 aim of deal.II is to enable rapid development of modern finite element codes,
 using among other aspects adaptive meshes and a wide array of tools classes
 often used in a finite element program.
 .
 This package contains the documentation.

Package: deal.ii-examples
Architecture: all
Section: doc
Depends: ${misc:Depends}
Recommends: libdeal.ii-dev
Description: Finite element library - documentation
 deal.II is a C++ program library targeted at the computational
 solution of partial differential equations using adaptive finite elements.
 It uses state-of-the-art programming techniques to offer you a modern
 interface to the complex data structures and algorithms required.  The main
 aim of deal.II is to enable rapid development of modern finite element codes,
 using among other aspects adaptive meshes and a wide array of tools classes
 often used in a finite element program.
 .
 This package contains the tutorial examples' source code.
